import { $x, $xy, $xyz, texture, } from "@thi.ng/shader-ast";
import { indexToUV } from "./index-uv";
/**
 * Inline function. Returns x component at index `i` in `tex`.
 *
 * @param tex -
 * @param i -
 * @param size -
 */
export const readIndex1 = (tex, i, size) => $x(readIndex4(tex, i, size));
/**
 * Inline function. Returns vec2 (x,y components) at index `i` in `tex`.
 *
 * @param tex -
 * @param i -
 * @param size -
 */
export const readIndex2 = (tex, i, size) => $xy(readIndex4(tex, i, size));
/**
 * Inline function. Returns vec3 (x,y,z components) at index `i` in `tex`.
 *
 * @param tex -
 * @param i -
 * @param size -
 */
export const readIndex3 = (tex, i, size) => $xyz(readIndex4(tex, i, size));
/**
 * Inline function. Returns vec4 at index `i` in `tex`.
 *
 * @param tex -
 * @param i -
 * @param size -
 */
export const readIndex4 = (tex, i, size) => texture(tex, indexToUV(i, size));
